{{ Read a 74hc597
}}

VAR
  Byte  bitno
  long  LatchData,LatchBuffer
  Word  LatchStack[7] 
  
CON
    _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000

' Pin /Port assignments for reference - these are passed from the Interface Program
'sload   = 15
'rck     = 14
'sck     = 23
'sclr    = 16
'Qh      = 12

  
PUB Start(sload,rck,sck,sclr,Qh) :Success
  
  Success := cognew(Main(sload,rck,sck,sclr,Qh), @LatchStack)  

PUB Main(sload,rck,sck,sclr,Qh)

  dira[sload] := 1              'Output
  dira[rck]   := 1              '
  dira[sck]   := 1              '
  dira[sclr]  := 1              '
  dira[Qh]    := 0              ' Input for data

  outa[sload] := 1              ' active low
  outa[rck]   := 0              '
  outa[sck]   := 0              ' Main clock
  outa[sclr]  := 1              ' active low

' Clear Shift Register
  outa[sclr] := 0
  ClockLatch(sck)                    ' Two clocks
  ClockLatch(sck)
  outa[sclr] := 1
   
Repeat
  ' Load input registers 
  outa[rck] :=1
  ClockLatch(sck)
  outa[rck] :=0
  ' Load Shift registers
  outa[sload] :=0               ' Active Low
  clockLatch(sck)
  outa[sload] :=1
  LatchBuffer :=0
  repeat bitno from 0 to 31
    ClockLatch(sck)
    LatchBuffer := LatchBuffer + ina[Qh]
    LatchBuffer := LatchBuffer << 1   

  LatchData :=LatchBuffer >>2
    
pub GetLatch : Bufr
           Bufr := LatchData
           
PUB ClockLatch(CL)
      ' ----------------------------- Clock AD ------------------
      waitcnt((2_000 + cnt))        ' Wait t_setup = 240 nS  
      OUTA[CL] := 1                  ' Clock up            
      waitcnt((2_000 + cnt))        ' Wait t_setup = 240 nS
      OUTA[CL] := 0                  ' Clock Down      
      ' ----------------------------- Clock AD ------------------