{{
                ADC088S052 Data Acquisition cog
}}
VAR
  Byte  bitno,ADdata,ADTemp, Chan
  Byte  AData[8],ADQual[8]  
  'Long  AD0,AD1,AD2,AD3,AD4,AD5,AD6,AD7 
  long  ADStack[35]
CON
    _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000
         
PUB Start(CL,DI,DO,CS) :Success
  ' CL = Clock         {P19}
  ' DI = Data In       {P18}
  ' DO = Data Out      {P21}
  ' CS = Chips Select  {P20}
  
  Success := cognew(Main(CL,DI,DO,CS), @ADStack)  

PUB Main(CL,DI,DO,CS)
  dira[CL] ~~                   ' Clock output to AD
  dira[DI] ~~                   ' Data OUT from Prop to AD(in)
  dira[DO] ~                    ' Data IN from AD(out) to Prop
  dira[CS] ~~                   ' Chip select - active low 
                                ' Wake Up chip with some 0's here.
  outa[CS] := 0                 ' CS on to non-active state
  outa[CL] := 0                 ' Make sure clock is low
  outa[DI] := 0                 ' Set DI to AD low
                                '
  waitcnt((2_000_000 + cnt))    ' Wait for everything to settle 
  outa[CS] := 1                 ' CS on to non-active state
  outa[CL] := 0                 ' Make sure clock is low
  outa[DI] := 0                 ' Set DI to AD low
  waitcnt((2_000_000 + cnt))    ' Wait for everything to settle
  Chan := 0                     ' Set Channel to 0 (chan 1 will be first b/c of increment location)   
  Repeat                         ' Start read loop on 8 chan AD converter 
    Chan ++                      ' Rotate Channel assignments
    if Chan == 8                 ' If Chan gets to 8 then reset it to 0
      Chan :=0                   '    count will be 0 - 7
    Outa[CL] :=0                 ' Clock in LOW position
    Outa[CS] :=0                 ' Chip Select low   
    Outa[DI] :=0                 ' Set Data IN to 0 - ADC really does not care 
    waitcnt((2_000 + cnt))       ' Wait t_setup = 480 nS  
                          
    ClockAD(CL)                  ' Clock 1     up -> Down
    ClockAD(CL)                  ' Clock 2     up -> Down
                                              
    Outa[DI] := ((Chan &  %00000100) >> 2) ' get Third bit then rotate chan down and put it on DI (bit 1)    
    ClockAD(CL)                  ' Clock 3     up -> Down                                                    
    Outa[DI] := ((Chan &  %00000010) >> 1) ' ' get second bit then rotate chan down and put it on DI (bit 2))
    ClockAD(CL)                  ' Clock 4     up -> Down                                                                                                                                             
    Outa[DI] := (Chan &  %00000001) ' Get First bit of chan and put it on DI (bit 3) 
                                 ' Clock is LOW here
    AdTemp := %10000000          ' Set AdTemp or the bit adder to 1 in MSB position
    AData[Chan] := 0                ' Set data byte to all zeros   
    Repeat bitno from 0 to 7      ' Go around 8 times once per bit     
      if ina[DO] == 1             ' If the input is a 1 add ADTemp to AD[chan] if 0 then pass to next bit  
        AData[Chan] := AdTemp + AData[Chan] ' AD[chan] the bit adder to the data byte
      AdTemp := AdTemp >> 1       ' Rotate the bit adder to the next lower bit position
      ClockAD(CL)                  ' Clock up -> Down , Clock 5 - 13 the AD to move to the next bit 

    Repeat bitno from 1 to 3      ' Use bitno as a holder for this count
      ClockAD(CL)                 ' Clock 14 - 16 per timing diagram
                                  ' Shut down the ADC
    Outa[CS] := 1                 ' Chip Select back to High  
    waitcnt((20_000 + cnt))        ' Wait for ADC to settle

    ADQual[Chan] := (AData[Chan] + ADQual[Chan])/2

PUB ClockAD(CL)
      ' ----------------------------- Clock AD ------------------
      waitcnt((2_000 + cnt))        ' Wait t_setup = 240 nS  
      OUTA[CL] := 1                  ' Clock up            
      waitcnt((2_000 + cnt))        ' Wait t_setup = 240 nS
      OUTA[CL] := 0                  ' Clock Down      
      ' ----------------------------- Clock AD ------------------

PUB GetAD(ChanReq) : AdDataOut
  case ChanReq
    1:
        AdDataOut := (100 * ADQual[ChanReq])/255
    2:
        AdDataOut := (100 * ADQual[ChanReq])/255
    3:
        AdDataOut :=(((((100 * ADQual[ChanReq])/255) - 29) * (100/70)) <# 100 ) #> 0
    4:
        AdDataOut := (100 * ADQual[ChanReq])/255
    5:
        AdDataOut := (100 * ADQual[ChanReq])/255
    6:
        AdDataOut := (100 * ADQual[ChanReq])/255
    7:
        AdDataOut :=(((((100 * ADQual[ChanReq])/255) - 36) * (100/24)) <# 100 ) #> 0



    